
/* wb_t@C	*/
#include <avr\io.h>
#include <avr\interrupt.h>

/* Lϐ	*/
uint8_t target_detect;	/* ^[QbgoIÕTvO	*/
uint8_t USB_detect;		/* USBoIÕTvO			*/
uint16_t B_POWER_wait;	/* Bdx^C}					*/

void PORT_initialise(void);
void TIMER_initialise(void);

/* 10ms荞	*/
SIGNAL(SIG_OUTPUT_COMPARE0A){
/*interrupt timer(void){*/
	/* ^[Qbgo|[g/USBo|[gTvO				*/
	/* Olʃrbg֒ǂoAʃrbgɍŐVli[B		*/
	/* 8rbgǂŔ肳B(8Tv̑Sv)	*/
	target_detect = (target_detect << 1) | ( ( PINB & _BV(PINB2) ) >> PINB2 );
//	target_detect = 0x00;
	USB_detect = (USB_detect >> 1) | ( PINA & _BV(PINA7) );

	/* Bdx^C}̃JEg_E	*/
	/*        0:ҋ@				*/
	/*        1:JEg_EI		*/
	/* ȊO:JEg_E		*/
	if( B_POWER_wait > 1 ){
		B_POWER_wait--;
	}
#if 0
	if(PINA & _BV(PA1)){
		PORTA &= ~(_BV(PA1)); 
	}else{
		PORTA |= _BV(PA1);
	}
#endif
}

/* C֐	*/
int main(void){
	cli();										/* 荞݋֎~				*/
	PORT_initialise();							/* |[g̏			*/
	PORTA &= ~(_BV(PA0) | _BV(PA1) | _BV(PA2));	/* [ݒ菉l			*/
												/* PA0:q[^[OFF			*/
												/* PA1:BdOFF				*/
												/* PA2:Zt[d			*/
	target_detect = 0xaa;						/* ^[Qbgoϐl	*/
	USB_detect = 0xaa;							/* USBoϐl		*/
	B_POWER_wait = 0;							/* Bd^C}l		*/
	TIMER_initialise();							/* 10ms荞ݏ	*/
	sei();										/* 荞݋				*/
	while(1){

#if 1
		/* ^[Qbǧo	*/
		if( target_detect == 0x00 ){
			/* 8TvSLȂ^[QbgLƔ	*/
			if( B_POWER_wait == 0 ){
				/* ^[QbgBd^C}ҋ@ԂȂq[^[n	*/
				PORTA |= _BV(PA0);
				B_POWER_wait = 15*(1000/10);	/* 15bŘc݂̖o	*/
			}
			/* USB̌o	*/
			if(USB_detect == 0xff ){
				/* 8TvSHȂUSBڑꂽ̂Ɣ	*/
				/* Zt[df								*/
				PORTA &= ~_BV(PA2);
			}else if (USB_detect == 0x00 ){
				/* 8TvSLȂUSBڑƔ			*/
				/* Zt[ds								*/
				PORTA |= _BV(PA2);
			}
		}else if( target_detect == 0xff ){
			/* 8TvSHȂ^[QbgƔ	*/
			PORTA &= ~( _BV(PA2) | _BV(PA1) | _BV(PA0) );	/* q[^[/BdJbg		*/
			B_POWER_wait = 0;						/* Bd^C}ҋ@Ԃɂ	*/
		}

		/* Bd^CAEgŒʓd	*/
		if( B_POWER_wait == 1 ){
			PORTA |= _BV(PA1);
		}

#endif
	}
	return 0;
}

/*	|[g	*/
void PORT_initialise(void){
	//			++++-------0Œ
	//			||||+------PRTIM1
	//			|||||+-----PRTIM0
	//			||||||+----PRUSI
	//			|||||||+---PRADC
	PRR		= 0b00001011;

	MCUCR	= 0b00000000;

	//			+----------PORTA7 ́ivAbvjFUSBo
	//			|+---------PORTA6
	//			||+--------PORTA5
	//			|||+-------PORTA4
	//			||||+------PORTA3
	//			|||||+-----PORTA2 óFUSB D+,D-[qR[
	//			||||||+----PORTA1 óFBd[
	//			|||||||+---PORTA0 óFq[^[d[
	DDRA	= 0b00000111;
	PORTA	= 0b00000000;

	//			++++-------
	//			||||+------PORTB3
	//			|||||+-----PORTB2 ́ivAbvjFTargeto
	//			||||||+----PORTB1
	//			|||||||+---PORTB0
	DDRB	= 0b00000000;
	PORTB	= 0b00000100;
}

/* ^C}荞ݏ	*/
void TIMER_initialise(void){
	//			+----------COM0A1
	//			|+---------COM0A0
	//			||+--------COM0B1
	//			|||+-------COM0B0
	//			||||++-----0Œ
	//			||||||+----WGM01
	//			|||||||+---WGM00
	TCCR0A	= 0b00000010;

	//			+----------FOC0A
	//			|+---------FOC0B
	//			||++-------0Œ
	//			||||+------WGM02
	//			|||||+-----CS02
	//			||||||+----CS01
	//			|||||||+---CS00
	TCCR0B	= 0b00000011;	// ۯ8

	OCR0A	= 156;	// 10msݒ

	//			+++++------0Œ
	//			|||||+-----OCIE0B
	//			||||||+----OCIE0A
	//			|||||||+---TOIE0
	TIMSK0	= 0b00000010;	//OCR0ArvŊ荞ݔ 

}
